﻿using Battleship.DrawningObjects;
using Battleship.Generics;
using Battleship.MovementStrategy;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Battleship
{
    public partial class FormShipCollection : Form
    {
        /// <summary>
        /// Набор объектов
        /// </summary>
        private readonly ShipGenericCollection<DrawningShip,DrawningObjectShip> _ships;
        /// <summary>
        /// Конструктор
        /// </summary>
        public FormShipCollection()
        {
            InitializeComponent();
            _ships = new ShipGenericCollection<DrawningShip, DrawningObjectShip>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }
        /// <summary>
        /// Добавление объекта в набор
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonAddShip_Click(object sender, EventArgs e)
        {
            FormBattleship form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_ships + form.SelectedShip != -1) 
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _ships.ShowShips();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }

        private void buttonRemoveShip_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление",
           MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            if (_ships - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _ships.ShowShips();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }

        private void buttonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _ships.ShowShips();
        }

    }
}
